<template>
  <CModal
    :show.sync="isOpen"
    :close-on-backdrop="false"
    addContentClasses="modal-window"
  >
    <template #header>
      <h5>Приглашение пользователя</h5>
      <CButton
        variant="ghost"
        @click="closeModal(false)"
      >
        <CIcon
          name="cilX"
        />
      </CButton>
    </template>
    <template #footer>
      <CButton
        color="secondary"
        @click="closeModal(false)"
      >
        Отмена
      </CButton>
      <CButton
        color="primary"
        @click="closeModal(true)"
      >
        Сохранить
      </CButton>
    </template>
    <CContainer fluid>
      <CRow>
        <CCol>
          <CInput
            label="ФИО"
            v-model="user.name"
            :invalidFeedback="invalidNameMessage"
            :isValid="isInvalidName"
          />
        </CCol>
      </CRow>
      <CRow>
        <CCol>
          <CInput
            label="E-mail"
            v-model="user.email"
            :invalidFeedback="invalidEmailMessage"
            :isValid="isInvalidEmail"
          />
        </CCol>
        <CCol>
          <CSelect
            label="Должность"
            addInputClasses="customChevron"
            :options="postOptions"
            :value.sync="user.post"
            :invalidFeedback="invalidPostMessage"
            :isValid="isInvalidPost"
          />
        </CCol>
      </CRow>
      <CRow>
        <CCol>
          <CInput
            label="Логин"
            v-model="user.login"
            :invalidFeedback="invalidLoginMessage"
            :isValid="isInvalidLogin"
          />
        </CCol>
        <CCol>
          <CInput
            label="Пароль"
            type="password"
            v-model="user.password"
            :invalidFeedback="invalidPasswordMessage"
            :isValid="isInvalidPassword"
          />
        </CCol>
      </CRow>
      <CRow>
        <CCol>
        <span>
          Введите данные нового пользователя чтобы пригласить его в систему.
          Данные для входа будут отправлены на указанный вами email.
        </span>
        </CCol>
      </CRow>
    </CContainer>
  </CModal>
</template>

<script>
  import { mapActions } from 'vuex';
  import stringArrayToString from "../../../../utils/stringArrayToString";
  import modalClosingDuration from "../../../../constants/modalClosingDuration";
  import fieldWarnings from "../../../../constants/fieldWarnings";

  export default {
    name: "AdditionalUser",
    props: {
      isOpen: {
        // Состояние модального окна
        type: Boolean,
        default: false,
      },
      errors: {
        // Ошибки с бека после попытки сохранения нового пользователя
        type: Object,
        default: null,
      },
    },
    data() {
      return {
        user: {},
        userCopy: {},
        warnings: {},
        defaultWarnings: {},
        transformedErrors: null,
        isShowWarnings: false,
      };
    },
    computed: {
      isInvalidName() {
        return 'name' in this.warnings && this.isShowWarnings ? false : null;
      },
      invalidNameMessage() {
        return this.isInvalidName === false ? this.warnings.name : '';
      },
      isInvalidEmail() {
        return 'email' in this.warnings ? false : null;
      },
      invalidEmailMessage() {
        return this.isInvalidEmail === false ? this.warnings.email : '';
      },
      isInvalidPost() {
        return 'post' in this.warnings && this.isShowWarnings ? false : null;
      },
      invalidPostMessage() {
        return this.isInvalidPost === false ? this.warnings.post : '';
      },
      isInvalidLogin() {
        return 'login' in this.warnings && this.isShowWarnings ? false : null;
      },
      invalidLoginMessage() {
        return this.isInvalidLogin === false ? this.warnings.login : '';
      },
      isInvalidPassword() {
        return 'password' in this.warnings ? false : null;
      },
      invalidPasswordMessage() {
        return this.isInvalidPassword === false ? this.warnings.password : '';
      },
      postOptions() {
        return this.$store.state.users.roles.map(role => ({value: role.id, label: role.name}));
      },
    },
    watch: {
      isOpen(value) {
        if (value) {
          let post = '';
          if (!this.$store.state.users.roles.length) {
            this.$store.dispatch('getRoles')
              .then(roles => this.user.post = roles[0].id)
              .catch(response => {
                let message = '';
                if ('message' in response) message = response.message;
                this.addToast({
                  toastInfo: message,
                  isVisibleToast: true,
                });
              })
          } else {
            post = this.$store.state.users.roles[0].id;
          }
          this.user = {
            name: '',
            email: '',
            post,
            login: '',
            password: '',
          };
        } else {
          setTimeout(() => this.clearData(), modalClosingDuration);
        }
      },
      'user.name'(name) {
        if (name !== undefined) {
          const {message} = this.defaultWarnings.email;
          this.checkFieldValidation('name', name, message);
        }
      },
      'user.email'(email) {
        if (email !== undefined) {
          const {message, compareFunc} = this.defaultWarnings.email;
          this.checkFieldValidation('email', email, message, compareFunc);
        }
      },
      'user.post'(post) {
        if (post !== undefined) {
          const {message} = this.defaultWarnings.post;
          this.checkFieldValidation('post', post, message);
        }
      },
      'user.login'(login) {
        if (login !== undefined) {
          const {message} = this.defaultWarnings.login;
          this.checkFieldValidation('login', login, message);
        }
      },
      'user.password'(password) {
        if (password !== undefined) {
          const {message, compareFunc} = this.defaultWarnings.password;
          this.checkFieldValidation('password', password, message, compareFunc,);
        }
      },
      errors(newErrors) {
        // Отслеживание появления ошибок с бека.
        // Преобразование сообщений ошибок.
        // Копирование текущей информации о заполненых полях.
        // Запись ошибок с бека в локальные ошибки this.warnings.
        if (newErrors && this.isOpen) {
          const userCopy = {};
          const transformedErrors = Object.fromEntries(Object.entries(newErrors).map(([key, value]) => {
            userCopy[key] = this.user[key];
            return [key, stringArrayToString(value)];
          }));
          this.transformedErrors = {...transformedErrors};
          this.userCopy = {...userCopy};
          this.warnings = {...transformedErrors};
        }
      },
    },
    created() {
      this.defaultWarnings = {
        name: {message: fieldWarnings.emptyField},
        email: {
          message: fieldWarnings.wrongEmail,
          compareFunc: this.emailCompareFunc,
        },
        post: {message: fieldWarnings.emptyField},
        login: {message: fieldWarnings.emptyField},
        password: {
          message: fieldWarnings.shortPassword,
          compareFunc: this.passwordCompareFunc,
        },
      }
    },
    methods: {
      checkFieldValidation(
        field, value, warningMessage, compareFunc = value => value === '',
      ) {
        // Проверка поля на валидность
        // field String - название поля
        // value String - значение поля
        // warningMessage String - Текст, показываемый если поле не прошло валидацию
        // compareFunc Function - Функция валидирования поля
        const errors = this.transformedErrors;
        if (errors && field in errors && value === this.userCopy[field]) {
          this.$set(this.warnings, field, errors[field]);
        } else if (compareFunc(value)) {
          if (field in this.warnings) {
            this.warnings[field] = warningMessage;
          } else {
            this.$set(this.warnings, field, warningMessage);
          }
        } else if (field in this.warnings) {
          this.$delete(this.warnings, field);
        }
      },
      checkValidation() {
        // Проверка корректности данных в полях
        const {name, email, post, login, password} = this.user;
        const isEmptyWarnings = Object.keys(this.warnings).length === 0;
        return name !== '' && this.emailRegular.test(email)
          && post !== '' && login !== '' && password.length >= 8 && isEmptyWarnings;
      },
      closeModal(closeType) {
        if (closeType) {
          this.isShowWarnings = true;
          if (this.checkValidation()) {
            this.$emit('onClose', {closeType, data: this.user, modalType: 'addUser'});
          } else {
            this.updateValidation();
          }
        } else {
          this.$emit('onClose', {closeType, modalType: 'addUser'});
        }
      },
      emailCompareFunc(email) {
        // Функция для валидации поля email
        return this.isShowWarnings ? !this.emailRegular.test(email)
          : email !== '' && !this.emailRegular.test(email);
      },
      passwordCompareFunc(password) {
        // Функция для валидации поля пароля
        const {length} = password;
        return this.isShowWarnings ? length < 8 : length > 0 && length < 8;
      },
      updateValidation() {
        // Проверка валидности полей после нажатия на кнопку сохранения пользователя
        Object.entries(this.user).map(([key, value]) => {
          const {message, compareFunc} = this.defaultWarnings[key];
          this.checkFieldValidation(key, value, message, compareFunc);
        })
      },
      clearData() {
        this.user = {};
        this.userCopy = {};
        this.warnings = {};
        this.transformedErrors = null;
        this.isShowWarnings = false;
      },
      ...mapActions({addToast: 'toast/addToast'}),
    },
  }
</script>
